SystemOrganization addCategory: #'Glamour-Roassal-Interactive'!

GLMGlobalBrowserTemplate subclass: #GLMRoassalInteractive
	instanceVariableNames: ''
	classVariableNames: 'Repository'
	poolDictionaries: ''
	category: 'Glamour-Roassal-Interactive'!

!GLMRoassalInteractive commentStamp: 'BenComan 10/7/2012 21:13' prior: 0!
Provide a reference framework for interactive use of Roassal.  Package separately from main Roassal due dependency on Glamour.!

!GLMRoassalInteractive class methodsFor: 'as yet unclassified' stamp: 'BenComan 10/7/2012 20:59'!
elementMenu  
	
	^ ROMenuActivable new
		item: 'Add child element' action:
		[	:targetElement |
			targetElement add: self newElement.  
		];
	
		item: 'Re-apply current layout'  action:
		[	:targetElement |
			targetElement applyLayout.	
			self flag: '2. Need to work out why this does not redraw until cursor moves within bounds of future location of elements - or outside parent element'.
		];
	
		item: 'Apply vertical layout' action:
		[	:targetElement |
			targetElement layout: (ROVerticalLineLayout new gapSize: 20); applyLayout.	
			self flag: 'as 2. above'.
		];
	
		item: 'Apply horizontal layout' action:
		[	:targetElement |
			targetElement layout: (ROHorizontalLineLayout new gapSize: 20); applyLayout.	
			self flag: 'as 2. above'.
		];
	
		item: 'Apply grid layout' action:
		[	:targetElement |
			targetElement layout: (ROGridLayout new gapSize: 20); applyLayout.	
			self flag: 'as 2. above'.
		];

		item: 'Explore graphic element' action:
		[	:targetElement |
		targetElement explore.
		]

! !

!GLMRoassalInteractive class methodsFor: 'as yet unclassified' stamp: 'BenComan 10/2/2012 22:02'!
getShortcutButton
	"
	GLMRoassalInteractive getShortcutButton
	"
	( (PluggableButtonMorph on: GLMRoassalInteractive getState: nil action: #open) label: 'Interactive Roassal' ) openInHand.! !

!GLMRoassalInteractive class methodsFor: 'as yet unclassified' stamp: 'BenComan 10/7/2012 20:13'!
newElement
	| newElement |
	self flag: 'Original requirement for UUID no longer applicable.  Perhaps consider another way of naming new elements.'.
	newElement := ROElementWithLayout spriteOn: (UUID new asString copyFrom: 1 to: 8). 
	newElement + (ROLabel).  
	newElement @ ROLightlyHighlightable @ (self elementMenu) . 
	newElement layout: (ROGridLayout new gapSize: 20 ).
	^newElement 
	

! !

!GLMRoassalInteractive class methodsFor: 'as yet unclassified' stamp: 'BenComan 10/7/2012 19:23'!
sampleData
	"For initial debugging/development provide some sample data. See GLMGlobalBrowserTemplate>>open"

	| rawView outer repository |

	repository := OrderedCollection new.
	
	rawView := ROView new @ RODraggable.
	rawView add: ( outer := (self newElement) - ROLabel ).
	outer add: ((self newElement) on: ' 1. Right-click-here to add nodes and apply layouts').
	outer add: ((self newElement) on: ' 2. Note there is a bug where layouts are not applied until mouse moves to certain positions').
	outer add: ((self newElement) on: ' 3. Flip between each sample to work around bug where new elements are not immediately available in #details pane.').
	outer add: ((self newElement) on: ' 4. Try closing the editor, then re-open and continue from where you left off').
	outer add: ((self newElement) on: ' 5. Reset the sample data from Repository menu').
	outer layout: ROVerticalLineLayout; applyLayout.
	repository add: ( 'roassalSample1' -> rawView ).

	rawView := ROView new @ RODraggable.
	rawView add: ( outer := (self newElement) - ROLabel ).
	outer add: ((self newElement) on: ' saved sample').
	outer add: ((self newElement) on: ' close this editor then re-open editor').
	outer layout: ROVerticalLineLayout; applyLayout.
	repository add: ( 'roassalSample2' -> rawView ).
	
	^repository
		! !

!GLMRoassalInteractive methodsFor: 'as yet unclassified' stamp: 'BenComan 10/7/2012 20:44'!
buildBrowser
	"self open"
	browser := GLMTabulator new.
	browser  title: 'Interactive Roassal'.
	browser column: [ :column | column row: #repository; row: #elementTree; row: #details ].
	browser column: [ :column | column row: #drawing ].

	browser transmit 
		to: #repository;
		andShow: 
		[ 	:composer | 
			composer list 
				title: 'Drawings Repository';
				act: 
				[ 	:presentation :model | 
					self entityResetSampleData. 
					(browser pane port: #entity) value: self entity 
				] entitled: 'Reset all sample data';
				act: 
				[	:presentation :model |
					GLMRoassalInteractive browse.
				] entitled: 'Browse GLMRoassalInteractive'
		].
	
	browser transmit 
		from: #repository;
		to: #drawing;
		andShow:
		[	:composer |
			composer roassalRaw
				title: 'Drawing';
				painting: 
				[ 	:rawView :savedRoassalDrawing | 
					rawView initializeFrom: savedRoassalDrawing value. 			
				].
		].
	
	browser transmit
		from: #repository;
		to: #elementTree;
		andShow:
		[	:composer |
			composer tree
				display: [ :repositoryAssociation | repositoryAssociation value ];
				children: [ :parent | parent elements ].
		].	
		
	browser transmit 
		from: #elementTree;
		to: #details;
		andShow:
		[ 	:composer |  
			composer text
		].
	
	browser transmit
		from: #drawing;
		to: #details;
		andShow:
		[ 	:composer |  
			composer text
		].
! !

!GLMRoassalInteractive methodsFor: 'as yet unclassified' stamp: 'BenComan 10/7/2012 15:53'!
entity
	| view rawView outer |
	Repository ifNil: 
	[ 
		Repository := OrderedCollection new .
		self flag: 'For initial debugging/development provide some sample data. See GLMGlobalBrowserTemplate>>open'.
		Repository addAll: self class sampleData. "self sampleData"
	].	
	^Repository  ! !

!GLMRoassalInteractive methodsFor: 'as yet unclassified' stamp: 'BenComan 10/7/2012 16:24'!
entityResetSampleData
	"self new entityResetSampleData"
	| view rawView outer |
	Repository := nil.
	self entity.
! !

!GLMMorphicRenderer methodsFor: '*Glamour-Roassal-Interactive' stamp: 'BenComan 10/1/2012 10:07'!
renderRoassalRawPresentation: aPresentation
	^ GLMMorphicRoassalRawRenderer render: aPresentation from: self! !

ROElement subclass: #ROElementWithLayout
	instanceVariableNames: 'layout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Roassal-Interactive'!

!ROElementWithLayout commentStamp: 'BenComan 10/7/2012 21:16' prior: 0!
Remember the applied layout between rendering, saving and loading drawings.!

!ROElementWithLayout class methodsFor: 'as yet unclassified' stamp: 'BenComan 9/30/2012 18:30'!
layout: aROLayout on: anObject
	^(self on: anObject) layout: aROLayout
	
! !

!ROElementWithLayout methodsFor: 'accessing' stamp: 'BenComan 10/7/2012 20:59'!
add: newElement 
	super add: newElement.
	self applyLayout.
	self view signalUpdate.
	
		! !

!ROElementWithLayout methodsFor: 'accessing' stamp: 'BenComan 10/1/2012 22:42'!
applyLayout
	layout on: (self elements select: [ :el | el isNotEdge ])."edges: self edges".
	self flag: 'Next line exit condition is a hack so as to not yet extend ROView with #applyLayout'.
	(parent isKindOf: ROView) ifTrue: [^self ].   
	parent applyLayout.! !

!ROElementWithLayout methodsFor: 'accessing' stamp: 'BenComan 9/30/2012 18:29'!
initialize 
	super initialize.
	layout := RONullLayout.! !

!ROElementWithLayout methodsFor: 'accessing' stamp: 'BenComan 9/30/2012 12:12'!
layout
	^ layout! !

!ROElementWithLayout methodsFor: 'accessing' stamp: 'BenComan 9/30/2012 12:12'!
layout: anObject
	layout := anObject! !

!GLMCompositePresentation methodsFor: '*Glamour-Roassal-Interactive' stamp: 'BenComan 10/1/2012 08:49'!
roassalRaw
	^ self custom: GLMRoassalRawPresentation new! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicRoassalRawRenderer
	instanceVariableNames: 'myMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Roassal-Interactive'!

!GLMMorphicRoassalRawRenderer commentStamp: 'BenComan 10/7/2012 21:09' prior: 0!
Mostly a copy of GLMorphicRoassalRender, but changing "ROMorph on: view stack"
to "ROMorph on: rawView"!

!GLMMorphicRoassalRawRenderer methodsFor: 'rendering' stamp: 'BenComan 10/7/2012 21:04'!
actOnPresentationUpdate: ann
	| aView |
	self halt. "2012-10-07-BTC Not sure when this might be called - so force a hard stop to find out."
	aView := ROMondrianViewBuilder new.
	ann presentation renderOn: aView.
	myMorph setView: aView stack.! !

!GLMMorphicRoassalRawRenderer methodsFor: 'rendering' stamp: 'BenComan 10/7/2012 20:30'!
render: aRoassalPresentation
	| rawView |
	rawView := aRoassalPresentation view.
	aRoassalPresentation renderOn: rawView.
	aRoassalPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdate: to: self.
	myMorph := ROMorph on: rawView. 
	^ myMorph ! !

!ROView methodsFor: '*Glamour-Roassal-Interactive' stamp: 'BenComan 10/1/2012 12:22'!
eventHandler
	^ eventHandler! !

!ROView methodsFor: '*Glamour-Roassal-Interactive' stamp: 'BenComan 10/1/2012 12:15'!
initializeFrom: aROView
	super initialize.
	elements := aROView elements.
	camera := aROView camera.
	eventHandler := aROView eventHandler.
	title := aROView title.
	backgroundColor := aROView backgroundColor.! !

GLMRoassalPresentation subclass: #GLMRoassalRawPresentation
	instanceVariableNames: 'rawView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Roassal-Interactive'!

!GLMRoassalRawPresentation commentStamp: 'BenComan 10/7/2012 21:15' prior: 0!
Mostly a copy of GLMRoassalPresentation but removing call to 'applyLayout' from #renderOn: - so that in conjunction with ROElementWithLayout, layouts can be remembered between rendering, saving and loading drawings.!

!GLMRoassalRawPresentation methodsFor: 'accessing' stamp: 'BenComan 10/7/2012 20:25'!
renderGlamorouslyOn: aRenderer
	self registerAnnouncements.
	^ aRenderer renderRoassalRawPresentation: self! !

!GLMRoassalRawPresentation methodsFor: 'accessing' stamp: 'BenComan 10/2/2012 21:51'!
renderOn: rawViewparam
	self flag: 'find a smarter solution that does not depend on isKindOf:'. 
	self paintingBlock glamourValue: (
		(self entity isKindOf: GLMMultiValue) 
				ifTrue: [(GLMMultiValue with: rawViewparam) , self entity , (GLMMultiValue with: self)] 
				ifFalse: [GLMMultiValue with: rawViewparam with: self entity with: self]).
	self flag: 'This should be the responsibility of the the view'.
	self shouldPopulateSelection ifTrue: [
		rawViewparam allElementsDo: [:each | 
			each on: ROMouseClick do: [:event | self selection: each model ]] ].
	self view: rawViewparam! !

!GLMRoassalRawPresentation methodsFor: 'accessing' stamp: 'BenComan 10/1/2012 09:42'!
view
	^ rawView ifNil: [rawView := ROView new]! !

!GLMRoassalRawPresentation methodsFor: 'accessing' stamp: 'BenComan 10/1/2012 09:40'!
view: anObject
	rawView := anObject! !
